# -*- coding: utf-8 -*-
"""
Created on Sun May  8 12:06:10 2022

@author: lenovo
"""
# !/usr/bin/env Python3
# -*- coding: utf-8 -*-
# @Author   : Yueying Wang
# @FILE     : construction_cytokine.py
# @Time     : 2021/12/28 20:16
# @Software : spyder
# @Email   : wyy180320@163.com
import pandas as pd 
import numpy as np
import torch
from torch.utils.data import DataLoader#,Dataset,TensorDataset
import pickle
from AE import autoencoder
def splitnp(x):
    outlist=x.detach().numpy()
    out=pd.DataFrame(outlist)
    return out
def runmodel(model,my_dataset_loader):
    pred11=pd.DataFrame()
    pred21=pd.DataFrame()
    pred31=pd.DataFrame()
    pred41=pd.DataFrame()
    for i ,(x) in enumerate(my_dataset_loader):
        pred1,pred2,pred3,pred4=model(x)
        pred1,pred2,pred3,pred4=[splitnp(i) for i in [pred1,pred2,pred3,pred4]]
        pred11=pd.concat([pred11,pred1],axis=0)
        pred21=pd.concat([pred21,pred2],axis=0)
        pred31=pd.concat([pred31,pred3],axis=0)
        pred41=pd.concat([pred41,pred4],axis=0)
        #pred51=pd.concat([pred51,pred5],axis=0)
    return pred11,pred21,pred31,pred41
def structure(x1):
    sca =pickle.load(open('scalerAE.pkl', 'rb'))
    x=sca.transform(x1)
    xx=torch.from_numpy(x.astype(np.float32))
    my_dataset_loader=DataLoader(xx,batch_size=15,shuffle=False)
    model=torch.load('AE.pkl')
    pred11,pred21,pred31,pred41=runmodel(model,my_dataset_loader)
    #[pred11,pred21,pred31,pred41,pred51]=[cha(i) for i in [pred11,pred21,pred31,pred41,pred51]]
    out=[pred11,pred21,pred31,pred41]
    return out
def layer(x):
    out=pd.DataFrame()
    for i in range(0,4):
        a=x[i]
        out=pd.concat([out,a],axis=1)
    return out
def mypca(x):
    scaler = pickle.load(open('scaler_pca.pkl', 'rb'))
    data=scaler.transform(x)
    pca = pickle.load(open('pca.pkl', 'rb'))
    dataPca = pd.DataFrame(pca.transform(data))
    dataPca.index=x.index
    return dataPca
def construction(x):
    x1=structure(x)
    x2=layer(x1)
    cytokine=mypca(x2)
    return cytokine